public class GracefulThread extends Thread {
    // Ivoꂽtrue
    private volatile boolean shutdownRequested = false;

    // Iv
    public final void shutdownRequest() {
        shutdownRequested = true;
        interrupt();
    }

    // Ivoꂽǂ̃eXg
    public final boolean isShutdownRequested() {
        return shutdownRequested;
    }

    // 
    public final void run() {
        try {
            while (!isShutdownRequested()) {
                doWork();
            }
        } catch (InterruptedException e) {
        } finally {
            doShutdown();
        }
    }

    // 
    protected void doWork() throws InterruptedException {
    }

    // I
    protected void doShutdown() {
    }
}
